﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using SyncfusionMvcApplication64.Kanban;
using System.Collections;
using System.ComponentModel.DataAnnotations.Schema;
using Syncfusion.JavaScript.DataSources;

namespace SyncfusionMvcApplication64
{
    public partial class KanbanController : Controller
    {
        //
        // GET: /Kanban/
        public ActionResult KanbanFeatures()
        {
            var DataSource = new NorthwindDataContext().Tasks.Take(30).ToList();
            ViewBag.datasource = DataSource;
            return View();
        }
        public JsonResult GetProjectSubactivities(Syncfusion.JavaScript.DataManager dm, int IdProjectActivity)
        {
            var datos = GetProjectSubactivities().Where(x => x.IdProyectActivity == IdProjectActivity);
            //return Json(datos);
            DataResult result = new DataResult();
            result.result = datos.Skip(dm.Skip).Take(dm.Take).ToList();
            result.count = datos.Count();
            return Json(result, JsonRequestBehavior.AllowGet);

        }

        public JsonResult GetSubactivities(Syncfusion.JavaScript.DataManager dm)
        {
            var param = System.Web.HttpContext.Current.Request.Headers["data"];
            DataOperations ds = new DataOperations();
            IEnumerable datos = GetSubactivities().Where(x => x.IdActivity == Convert.ToInt16(param)).ToList();
            //return Json(datos);
            DataResult result = new DataResult();
            if(dm.Skip > 0)
            {
               datos =  ds.PerformSkip(datos, dm.Skip);
            }
            if (dm.Take > 0)
            {
                datos = ds.PerformTake(datos, dm.Take);
            }
            result.result = datos;
            result.count = datos.AsQueryable().Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        private static List<Subactivity> GetSubactivities()
        {
            List<Subactivity> lst = new List<Subactivity>();

            lst.Add(new Subactivity() { ID = 1, IdActivity = 1, Name = "Sectorization" });
            lst.Add(new Subactivity() { ID = 2, IdActivity = 1, Name = "DUP" });
            lst.Add(new Subactivity() { ID = 3, IdActivity = 2, Name = "Construction" });
            lst.Add(new Subactivity() { ID = 4, IdActivity = 2, Name = "Transformation" });
            lst.Add(new Subactivity() { ID = 5, IdActivity = 2, Name = "Authorization" });

            return lst;
        }

        private static List<ProjectSubactivity> GetProjectSubactivities()
        {
            List<ProjectSubactivity> lst = new List<ProjectSubactivity>();

            lst.Add(new ProjectSubactivity() { ID = 1, IdProyectActivity = 1, IdSubactivity = 1, Date = DateTime.Now, Weeks = 3, Finished = false });
            lst.Add(new ProjectSubactivity() { ID = 2, IdProyectActivity = 1, IdSubactivity = 2, Date = DateTime.Now, Weeks = 1, Finished = true });

            return lst;
        }


        public class ProjectSubactivity
        {
            public int ID { get; set; }

            public int IdProyectActivity { get; set; }

            public int IdSubactivity { get; set; }

            [Column(TypeName = "date")]
            public DateTime Date { get; set; }

            public int Weeks { get; set; }

            public bool Finished { get; set; }
        }

        public class Subactivity
        {
            public int ID { get; set; }

            public int IdActivity { get; set; }

            public string Name { get; set; }
        }

        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

    }
}